/* -*- buffer-read-only: t -*- vi: set ro:
#line 431
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 431
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MAIL
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_mail.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

static int
_send(eval_environ_t env,
      const char *mailer_url, char *to, char *from, mu_message_t msg,
      void (*destroy)(void*), void *ptr)
{
	int status;
	mu_mailer_t mailer;
	mu_address_t to_addr;
	mu_address_t from_addr = NULL;
	
	if (!mailer_url)
		mu_mailer_get_url_default(&mailer_url);
	status = mu_mailer_create(&mailer, mailer_url);
	if (status) {
		destroy(ptr);
			env_throw_bi(env, mf_failure, NULL, _("Cannot create mailer `%s': %s"),mailer_url,mu_strerror(status));
#line 36
;
	}
	status = mu_address_create(&to_addr, to);
	if (status) {
		destroy(ptr);
		mu_mailer_destroy(&mailer);
			env_throw_bi(env, mf_failure, NULL, _("Bad recipient address `%s': %s"),to,mu_strerror(status));
#line 44
;
	}
	
	if (!from || from[0] == 0)
		from = "<>";
	status = mu_address_create(&from_addr, from);
	if (status) {
		mu_address_destroy(&to_addr);
		mu_mailer_destroy(&mailer);
		destroy(ptr);
			env_throw_bi(env, mf_failure, NULL, _("Bad sender address `%s': %s"),from,mu_strerror(status));
#line 56
;
	}
	
	/* FIXME: mailer flags? */
	status = mu_mailer_open(mailer, 0);
	if (status) {
		mu_address_destroy(&to_addr);
		mu_address_destroy(&from_addr);
		mu_mailer_destroy(&mailer);
		destroy(ptr);
			env_throw_bi(env, mf_failure, NULL, _("Opening mailer `%s' failed: %s"),mailer_url,mu_strerror (status));
#line 68
;
	}
	
	status = mu_mailer_send_message(mailer, msg, from_addr, to_addr);
	mu_address_destroy(&to_addr);
	mu_address_destroy(&from_addr);
	mu_mailer_destroy(&mailer);
	destroy(ptr);
		if (!(status == 0))
#line 78
			env_throw_bi(env, mf_failure, NULL, _("Cannot send message: %s"),mu_strerror(status));
#line 78
;
#line 78
;
	return 0;
}

static void
_destroy_msg(void *ptr)
{
	mu_message_t msg = ptr;
	mu_message_destroy(&msg, mu_message_get_owner(msg));
}

#line 90
void
#line 90
bi_send_mail(eval_environ_t env)
#line 90

#line 90 "bi_mail.m4"
{
#line 90
	
#line 90
char * text = (char *) get_string_arg(env, 3);
#line 90
        char * to = (char *) get_string_arg(env, 2);
#line 90
        char * from = (char *) get_string_arg(env, 1);
#line 90
        char * mailer_url = (char *) get_string_arg(env, 0);
#line 90
        
#line 90
        adjust_stack(env, 4);
#line 90

#line 90
	if (prog_trace_option & BUILTIN_MASK_mail)
#line 90
		prog_trace(env, "send_mail %s %s %s %s",text, to, from, mailer_url);;
#line 90

{
	mu_message_t msg = NULL;
	mu_stream_t stream = NULL;

	mu_message_create(&msg, NULL);

	mu_message_get_stream(msg, &stream);
	mu_stream_write(stream, text, strlen(text), 0, NULL);
	
	_send(env, ((mailer_url && mailer_url[0]) ? mailer_url : NULL), to, 
              ((from && from[0]) ? from : NULL), msg, _destroy_msg, msg);
}
}

static void
add_headers(mu_message_t msg, char *headers)
{
	mu_stream_t stream = NULL;
	mu_header_t hdr = NULL;
	size_t len;

	if (!headers)
		return;
	
	len = strlen(headers);
	mu_message_get_header(msg, &hdr);
	mu_header_get_stream(hdr, &stream);
	mu_stream_write(stream, headers, len, 0, NULL);
	if (len < 2 || memcmp(headers + len - 2, "\n\n", 2)) {
		if (len > 1 && headers[len-1] == '\n')
			mu_stream_write(stream, "\n", 1, len, NULL);
		else
			mu_stream_write(stream, "\n\n", 2, len, NULL);
	}
}

#line 128
void
#line 128
bi_send_text(eval_environ_t env)
#line 128

#line 128 "bi_mail.m4"
{
#line 128
	
#line 128
char * text = (char *) get_string_arg(env, 4);
#line 128
        char * headers = (char *) get_string_arg(env, 3);
#line 128
        char * to = (char *) get_string_arg(env, 2);
#line 128
        char * from = (char *) get_string_arg(env, 1);
#line 128
        char * mailer_url = (char *) get_string_arg(env, 0);
#line 128
        
#line 128
        adjust_stack(env, 5);
#line 128

#line 128
	if (prog_trace_option & BUILTIN_MASK_mail)
#line 128
		prog_trace(env, "send_text %s %s %s %s %s",text, headers, to, from, mailer_url);;
#line 128

{
	mu_message_t msg = NULL;
	mu_body_t body = NULL;
	mu_stream_t stream = NULL;
	
	mu_message_create(&msg, NULL);

	mu_message_get_body(msg, &body);
	mu_body_get_stream(body, &stream);
	mu_stream_write(stream, text, strlen(text), 0, NULL);

	add_headers(msg, headers);
	_send(env, ((mailer_url && mailer_url[0]) ? mailer_url : NULL), to, 
              ((from && from[0]) ? from : NULL), msg, _destroy_msg, msg);
}
}


static int
_stream_printf(mu_stream_t stream, const char *fmt, ...)
{
	va_list ap;
	char *buf = NULL;
	size_t size;
	
	va_start(ap, fmt);
	vasprintf(&buf, fmt, ap);
	va_end(ap);
	size = strlen(buf);
	return mu_stream_sequential_write(stream, buf, size);
}

static void
mime_create_reason(mu_mime_t mime, const char *sender, const char *text)
{
	mu_message_t newmsg;
	mu_stream_t stream;
	time_t t;
	struct tm *tm;
	mu_body_t body;
	mu_header_t hdr;
	char datestr[80];
	static char *content_header =
		"Content-Type: text/plain;charset=US-ASCII\n" /* FIXME! */
		"Content-Transfer-Encoding: 8bit\n";
 
	mu_message_create(&newmsg, NULL);
	mu_message_get_body(newmsg, &body);
	mu_body_get_stream(body, &stream);

	time(&t);
	tm = localtime(&t);
	mu_strftime(datestr, sizeof datestr, "%a, %b %d %H:%M:%S %Y %Z", tm);

	_stream_printf(stream,
			 "\n"
			 "The original message was received at %s from %s.\n",
			 datestr, sender);

	mu_stream_sequential_write(stream, text, strlen(text));
	mu_stream_close(stream);
	mu_header_create(&hdr, content_header, strlen(content_header), newmsg);
	mu_message_set_header(newmsg, hdr, NULL);
	mu_mime_add_part(mime, newmsg);
	mu_message_unref(newmsg);
}

static void
mime_create_ds(mu_mime_t mime, char *recpt)
{
	mu_message_t newmsg;
	mu_stream_t stream;
	mu_header_t hdr;
	mu_body_t body;
	char datestr[80];
	time_t t;
	struct tm *tm;
	
	time(&t);
	tm = localtime(&t);
	mu_strftime(datestr, sizeof datestr, "%a, %b %d %H:%M:%S %Y %Z", tm);

	mu_message_create(&newmsg, NULL);
	mu_message_get_header(newmsg, &hdr); 
	mu_header_set_value(hdr, "Content-Type", "message/delivery-status", 1);
	mu_message_get_body(newmsg, &body);
	mu_body_get_stream(body, &stream);
	_stream_printf(stream, "Reporting-UA: %s\n", PACKAGE_STRING);
	_stream_printf(stream, "Arrival-Date: %s\n", datestr);
	_stream_printf(stream, "Final-Recipient: RFC822; %s\n",
			 recpt ? recpt : "unknown");
	_stream_printf(stream, "%s", "Action: deleted\n");
	_stream_printf(stream, "%s",
			  "Disposition: automatic-action/"
			  "MDN-sent-automatically;deleted\n");
	_stream_printf(stream, "Last-Attempt-Date: %s\n", datestr);
	mu_stream_close(stream);
	mu_mime_add_part(mime, newmsg);
	mu_message_unref(newmsg);
}

/* Quote original message */
static int
mime_create_quote(mu_mime_t mime, mu_stream_t istream)
{
	mu_message_t newmsg;
	mu_stream_t ostream;
	mu_header_t hdr;
	size_t ioff = 0, ooff = 0, n;
	char buffer[512];
	mu_body_t body;
    
	mu_message_create(&newmsg, NULL);
	mu_message_get_header(newmsg, &hdr); 
	mu_header_set_value(hdr, "Content-Type", "message/rfc822", 1);
	mu_message_get_body (newmsg, &body);
	mu_body_get_stream(body, &ostream);
  
	while (mu_stream_read(istream, buffer, sizeof buffer - 1,
			      ioff, &n) == 0
	       && n != 0) {
		size_t sz;
		mu_stream_write(ostream, buffer, n, ooff, &sz);
		if (sz != n)
			return EIO;
		ooff += n;
		ioff += n;
	}
	mu_stream_close(ostream);
	mu_mime_add_part(mime, newmsg);
	mu_message_unref(newmsg);
	return 0;
}
  
static int
build_mime(mu_mime_t *pmime, mu_stream_t msgstr,
	   char *sender, char *recpt,
	   char *text)
{
	mu_mime_t mime = NULL;
	int status;
  
	mu_mime_create(&mime, NULL, 0);
	mime_create_reason(mime, sender, text);
	mime_create_ds(mime, recpt);
	status = mime_create_quote(mime, msgstr);
	if (status) {
		mu_mime_destroy (&mime);
		return status;
	}
  
	*pmime = mime;
	return 0;
}

static void
_destroy_mime(void *ptr)
{
	mu_mime_t mime = ptr;
	mu_mime_destroy(&mime);
}



#line 295
void
#line 295
bi_send_dsn(eval_environ_t env)
#line 295

#line 295 "bi_mail.m4"
{
#line 295
	
#line 295
char * to = (char *) get_string_arg(env, 6);
#line 295
        char * sender = (char *) get_string_arg(env, 5);
#line 295
        char * recpt = (char *) get_string_arg(env, 4);
#line 295
        char * text = (char *) get_string_arg(env, 3);
#line 295
        char * headers = (char *) get_string_arg(env, 2);
#line 295
        char * from = (char *) get_string_arg(env, 1);
#line 295
        char * mailer_url = (char *) get_string_arg(env, 0);
#line 295
        
#line 295
        adjust_stack(env, 7);
#line 295

#line 295
	if (prog_trace_option & BUILTIN_MASK_mail)
#line 295
		prog_trace(env, "send_dsn %s %s %s %s %s %s %s",to, sender, recpt, text, headers, from, mailer_url);;
#line 295

{
	int status;
	mu_mime_t mime;
	mu_message_t newmsg;
	
	status = build_mime(&mime, env_get_stream(env),
			    sender, recpt, text);
		if (!(status == 0))
#line 306
			env_throw_bi(env, mf_failure,                                             "send_dsn: ", _("Cannot create DSN: %s"),mu_strerror(status));
#line 306
;
#line 306
;

	mu_mime_get_message(mime, &newmsg);
	add_headers(newmsg, ((headers && headers[0]) ? headers : NULL));
	_send(env, ((mailer_url && mailer_url[0]) ? mailer_url : NULL), to, 
              ((from && from[0]) ? from : NULL), newmsg, _destroy_mime, mime);
}
}


#line 315
void
#line 315
mail_init_builtin()
#line 315
{
#line 315
	#line 90 "bi_mail.m4"
va_builtin_install_ex("send_mail", bi_send_mail, 0, 0, dtype_unspecified,  4, 2,  dtype_string, dtype_string, dtype_string, dtype_string);
#line 128 "bi_mail.m4"
va_builtin_install_ex("send_text", bi_send_text, 0, 0, dtype_unspecified,  5, 2,  dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);
#line 295 "bi_mail.m4"
va_builtin_install_ex("send_dsn", bi_send_dsn, EXMASK(smtp_state_eom), 1, dtype_unspecified,  7, 3,  dtype_string, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);

#line 315 "bi_mail.m4"
		
#line 315
}
#line 0

#line 0

