/* -*- buffer-read-only: t -*- vi: set ro:
#line 431
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 431
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_OTHER
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 17 "bi_other.m4"
/* This file is part of mailfromd.             -*- c -*-
#line 17
   Copyright (C) 2006, 2007 Sergey Poznyakoff
#line 17

#line 17
   This program is free software; you can redistribute it and/or modify
#line 17
   it under the terms of the GNU General Public License as published by
#line 17
   the Free Software Foundation; either version 2, or (at your option)
#line 17
   any later version.
#line 17

#line 17
   This program is distributed in the hope that it will be useful,
#line 17
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 17
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 17
   GNU General Public License for more details.
#line 17

#line 17
   You should have received a copy of the GNU General Public License
#line 17
   along with this program; if not, write to the Free Software
#line 17
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#line 17
   MA 02110-1301 USA */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

#if HAVE_MU_GET_AUTH
	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
                	env_throw_bi(env, mf_temp_failure, NULL, _("Temporary failure querying for username %s"),name);
#line 40
;
		break;

	default:
                	env_throw_bi(env, mf_failure, NULL, _("Failure querying for username %s"),name);
#line 46
;
		break;
	}
#else
	auth_data = mu_get_auth_by_name(name);
	rc = auth_data != NULL;
	mu_auth_data_free(auth_data);
#endif
	debug2(10, "Checking user %s: %s", name,
	       rc ? "true" : "false");
	return rc;
}

void
#line 59
bi_validuser(eval_environ_t env)
#line 59

#line 59 "bi_other.m4"
{
#line 59
	
#line 59
char * name = (char *) get_string_arg(env, 0);
#line 59
        
#line 59
        adjust_stack(env, 1);
#line 59

#line 59
	if (prog_trace_option & BUILTIN_MASK_other)
#line 59
		prog_trace(env, "validuser %s",name);;
#line 59

{
	do {
#line 61
push(env, (STKVAL) (valid_user_p(env, name)));
#line 61
return;
#line 61
} while (0);
}
}

void
#line 65
bi_interval(eval_environ_t env)
#line 65

#line 65 "bi_other.m4"
{
#line 65
	
#line 65
char * str = (char *) get_string_arg(env, 0);
#line 65
        
#line 65
        adjust_stack(env, 1);
#line 65

#line 65
	if (prog_trace_option & BUILTIN_MASK_other)
#line 65
		prog_trace(env, "interval %s",str);;
#line 65

{
       time_t t;
       const char *endp;

       	if (!(parse_time_interval(str, &t, &endp) == 0))
#line 72
			env_throw_bi(env, mf_invtime,                                             "interval: ", _("Unrecognized time  (near `%s')"),endp);
#line 72
;
#line 72
;
       do {
#line 73
push(env, (STKVAL) (t));
#line 73
return;
#line 73
} while (0);
}
}

void
#line 77
bi_rate(eval_environ_t env)
#line 77

#line 77 "bi_other.m4"
{
#line 77
	
#line 77
char * key = (char *) get_string_arg(env, 1);
#line 77
        long  interval = (long ) get_numeric_arg(env, 0);
#line 77
        
#line 77
        adjust_stack(env, 2);
#line 77

#line 77
	if (prog_trace_option & BUILTIN_MASK_other)
#line 77
		prog_trace(env, "rate %s %lu",key, interval);;
#line 77

{
	double rate;
	long lrate;
		
		if (!(get_rate(key, &rate) == mf_success))
#line 84
			env_throw_bi(env, mf_dbfailure,                                             "rate: ", _("Cannot get rate for %s"),key);
#line 84
;
#line 84
;
	lrate = rate * interval;
	
	do {
#line 87
push(env, (STKVAL) (lrate));
#line 87
return;
#line 87
} while (0);
}
}

void
#line 91
bi_debug_level(eval_environ_t env)
#line 91

#line 91 "bi_other.m4"
{
#line 91
	
#line 91
char * modname = (char *) get_string_arg(env, 0);
#line 91
        
#line 91
        adjust_stack(env, 1);
#line 91

#line 91
	if (prog_trace_option & BUILTIN_MASK_other)
#line 91
		prog_trace(env, "debug_level %s",modname);;
#line 91

{
	int level;
		if (!(debug_module_level(((modname && modname[0]) ? modname : NULL), &level) == 0))
#line 96
			env_throw_bi(env, mf_range,                                             "debug_level: ", _("Invalid module name: %s"),modname);
#line 96
;
#line 96
;
	do {
#line 97
push(env, (STKVAL) (level));
#line 97
return;
#line 97
} while (0);
}
}

void
#line 101
bi_debug_spec(eval_environ_t env)
#line 101

#line 101 "bi_other.m4"
{
#line 101
	
#line 101
char * modnames = (char *) get_string_arg(env, 0);
#line 101
        
#line 101
        adjust_stack(env, 1);
#line 101

#line 101
	if (prog_trace_option & BUILTIN_MASK_other)
#line 101
		prog_trace(env, "debug_spec %s",modnames);;
#line 101

{
	char *buf;
	char *s;
	size_t off;

 	int rc = debug_spec_string(((modnames && modnames[0]) ? modnames : NULL), &buf);
		if (!(rc == 0))
#line 110
			env_throw_bi(env, mf_failure,                                             "debug_spec: ", "%s",mu_strerror(rc));
#line 110
;
#line 110
;
	s = (char*) env_data_ref(env, (off = heap_reserve(env, strlen(buf) + 1)));
	strcpy(s, buf);
	free(buf);
	do {
#line 114
push(env, (STKVAL) (off));
#line 114
return;
#line 114
} while (0);
}
}

void
#line 118
bi_debug(eval_environ_t env)
#line 118

#line 118 "bi_other.m4"
{
#line 118
	
#line 118
char * spec = (char *) get_string_arg(env, 0);
#line 118
        
#line 118
        adjust_stack(env, 1);
#line 118

#line 118
	if (prog_trace_option & BUILTIN_MASK_other)
#line 118
		prog_trace(env, "debug %s",spec);;
#line 118

{
	debug_parse_spec(spec);
}
}

void
#line 124
bi_program_trace(eval_environ_t env)
#line 124

#line 124 "bi_other.m4"
{
#line 124
	
#line 124
char * name = (char *) get_string_arg(env, 0);
#line 124
        
#line 124
        adjust_stack(env, 1);
#line 124

#line 124
	if (prog_trace_option & BUILTIN_MASK_other)
#line 124
		prog_trace(env, "program_trace %s",name);;
#line 124

{
	enable_prog_trace(name);
}
}

void
#line 130
bi_cancel_program_trace(eval_environ_t env)
#line 130

#line 130 "bi_other.m4"
{
#line 130
	
#line 130
char * name = (char *) get_string_arg(env, 0);
#line 130
        
#line 130
        adjust_stack(env, 1);
#line 130

#line 130
	if (prog_trace_option & BUILTIN_MASK_other)
#line 130
		prog_trace(env, "cancel_program_trace %s",name);;
#line 130

{
	disable_prog_trace(name);
}
}	

void
#line 136
bi_stack_trace(eval_environ_t env)
#line 136

#line 136 "bi_other.m4"
{
#line 136
	
#line 136

#line 136
        adjust_stack(env, 0);
#line 136

#line 136
	if (prog_trace_option & BUILTIN_MASK_other)
#line 136
		prog_trace(env, "stack_trace");;
#line 136

{
	runtime_stack_trace(env);
}
}


#line 142
void
#line 142
other_init_builtin()
#line 142
{
#line 142
	#line 59 "bi_other.m4"
va_builtin_install_ex("validuser", bi_validuser, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 65 "bi_other.m4"
va_builtin_install_ex("interval", bi_interval, 0, 0, dtype_number,  1, 0,  dtype_string);
#line 77 "bi_other.m4"
va_builtin_install_ex("rate", bi_rate, 0, 0, dtype_number,  2, 0,  dtype_string, dtype_number);
#line 91 "bi_other.m4"
va_builtin_install_ex("debug_level", bi_debug_level, 0, 0, dtype_number,  1, 1,  dtype_string);
#line 101 "bi_other.m4"
va_builtin_install_ex("debug_spec", bi_debug_spec, 0, 0, dtype_string,  1, 1,  dtype_string);
#line 118 "bi_other.m4"
va_builtin_install_ex("debug", bi_debug, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 124 "bi_other.m4"
va_builtin_install_ex("program_trace", bi_program_trace, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 130 "bi_other.m4"
va_builtin_install_ex("cancel_program_trace", bi_cancel_program_trace, 0, 0, dtype_unspecified,  1, 0,  dtype_string);
#line 136 "bi_other.m4"
va_builtin_install_ex("stack_trace", bi_stack_trace, 0, 0, dtype_unspecified,  0, 0,  dtype_unspecified);

#line 142 "bi_other.m4"
		
#line 142
}
#line 0

#line 0

